# frozen_string_literal: true

module Hyrax
  class DownloadSearchJob < ApplicationJob
    include ComplexFilterHelper

    def perform(current_user_id, doc_ids, shell_file_path, download_link, parents_source_identifier, search_params, skip_filters= false)
      current_user = ::User.find_by(id: current_user_id) if current_user_id

      unless File.exist?(shell_file_path)
        prepare_download_file(shell_file_path, doc_ids, search_params, parents_source_identifier, skip_filters)
      end

      return unless current_user.present?

      subject = I18n.t('hyrax.notifications.download_ready.subject')
      message = I18n.t('hyrax.notifications.download_ready.message',
                  link:  nil,
                  download_link: download_link,
                  user: current_user.user_key)

      Hyrax::MessengerService.deliver(current_user, current_user, message, subject)
    end
  end
end
